/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.*;

public class Background extends GameObjectDecorator{

    private Image tileImg;
    private TiledLayer tiledlayer;
    private int tileWid = 20, tileHgt = 20;   // Width, height of each tile
    private int stIndex, atIndex;             // Static, Animated tile index
    private int indx;
    private long lastTime;

    public Background(GameObject gameObject){
        super(gameObject);
        lastTime = System.currentTimeMillis();
        int[][] grid =              // grid[row][col]
        {  {5, 5, 5, 5, 5, 5, 5, 5, 5, 5},      // Top row
           {5, 1, 1, 5, 5, 5, 5, 1, 1, 5},
           {5, 1, 5, 5, 5, 5, 5, 1, 5, 5},
           {5, 1, 1, 5, 5, 5, 5, 1, 1, 5},
           {5, 5, 5, 5, 5, 5, 5, 1, 5, 5},
           {5, 1, 5, 5, 5, 5, 5, 1, 5, 5},
           {5, 1, 1, 5, 5, 5, 5, 1, 5, 5},
           {5, 1, 1, 5, 5, 5, 5, 1, 1, 5},
           {5, 1, 5, 5, 5, 5, 5, 1, 5, 5},
           {5, 5, 5, 5, 5, 5, 5, 5, 5, 5}      // Bottom row
        };
        stIndex = 1;    //Static index of the tile to be animated (water)
        try{
            tileImg = Image.createImage("/bckgrnd.png");
            tiledlayer = new TiledLayer(10, 10, tileImg, tileWid, tileHgt);

            atIndex = tiledlayer.createAnimatedTile(stIndex);  //get the animated tile index

            for(int i=0; i<10; i++)         // for each row
            {
                for(int j=0; j<10; j++)      // for each column of row i
                {
                    indx = grid[i][j];
                    if(indx == stIndex) indx = atIndex;  //Use animated index for 5
                    tiledlayer.setCell(j, i, indx);  // col, row, index
                }
            }
        }
        catch(Exception e){
            System.out.println("Error loading sprite!!");
        }
    }

    public void update(){
        if ((System.currentTimeMillis() - lastTime > 500)){
            stIndex ++;
            if(stIndex==5){
                stIndex = 1;
            }   //cycle through indices 5, 6, 7.
            tiledlayer.setAnimatedTile(atIndex, stIndex);
            lastTime = System.currentTimeMillis();
        }
    }

    public void addToLayerManager(LayerManager layerManager){
        layerManager.append(tiledlayer);
    }
}
