/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import gamelibrary.game.Coordinates;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.*;

public class Foe extends GameObjectDecorator{

    private Image spriteImg;
    private int speed;
    private Coordinates coordinates;
    private GameObject victim;
    private int lastX = 0;
    private int lastY = 0;

    public Foe(GameObject gameObject, Coordinates coordinates, int speed, GameObject victim){
        super(gameObject);
        this.speed = speed;
        this.coordinates = coordinates;
        this.victim = victim;
        try
        {
            int[] seq = {0, 0, 0, 0, 1, 1, 1, 1};  //Frame sequence
            spriteImg = Image.createImage("/foe.png");
            sprite = new MySprite(spriteImg, 1, 2);
            sprite.setFrameSequence(seq);
            sprite.defineReferencePixel(sprite.getWidth()/2, sprite.getHeight()/2);
            sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        }
        catch(Exception e)
        {
            System.out.println("Error loading sprite!!");
        }
    }

    public void chase(){
        int howFarX = 0;
        int howFarY = 0;
        int distanceX = victim.getCoordinates().getX() - coordinates.getX();
        int distanceY = victim.getCoordinates().getY() - coordinates.getY();
        if (distanceX > distanceY){
            if(distanceX > 0){
                howFarX += speed;
            }
            else if(distanceX < 0){
                howFarX -= speed;
            }
        }
        else{
            if(distanceY > 0){
                howFarY += speed;
            }
            else if(distanceY < 0){
                howFarY -= speed;
            }
        }
        move(howFarX, howFarY);
    }

    public boolean move(int howFarX, int howFarY){
        super.move(howFarX, howFarY);
        coordinates.addX(howFarX);
        coordinates.addY(howFarY);
        sprite.nextFrame();
        sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        lastX = howFarX;
        lastY = howFarY;
        return true;
    }

    public boolean undoLastMove(){
        super.undoLastMove();
        int howFarX = -lastX;
        int howFarY = -lastY;
        int distanceX = victim.getCoordinates().getX() - coordinates.getX();
        int distanceY = victim.getCoordinates().getY() - coordinates.getY();
        //if last move was left
        if ((lastX < 0)){
            if (distanceY < 0){
                howFarY += speed;
            }
            else{
                howFarY -= speed;
            }
        }
        //if last move was right
        else if (lastX > 0){
            if (distanceY > 0){
            howFarY += speed;
            }
            else{
                howFarY -= speed;
            }
        }
        //if last move was up
        else if ((lastY < 0)){
            if (distanceX > 0){
                howFarX += speed;
            }
            else{
                howFarX -= speed;
            }
        }
        //if last move was down
        else if ((lastY > 0)){
            if (distanceX > 0){
                howFarX += speed;
            }
            else{
                howFarX -= speed;
            }
        }
        move(howFarX, howFarY);
        return true;
    }

    public Coordinates getCoordinates(){
        return coordinates;
    }

    public void setVictim(GameObject victim){
        this.victim = victim;
    }

    public void addToLayerManager(LayerManager layerManager){
        layerManager.append(sprite);
    }

    public boolean collidesWith(GameObject foreign){
        return foreign.collidesWith(sprite);
    }

    public boolean collidesWith(Sprite otherSprite){
        return sprite.collidesWith(otherSprite, true);
    }
}
