/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import java.util.Vector;
import gamelibrary.game.Coordinates;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.*;
import gamelibrary.collisiondetection.Solid;

public class Maze{

    private Vector mazeSegs;
    private Vector coordinates;
    private PacDots pacdots;

    public Maze(Coordinates maxScreenCoords){
        coordinates = new Vector();
        mazeSegs = new Vector();
        pacdots = new PacDots(20);
        makeBorder(maxScreenCoords);
        //wall 1
        coordinates.addElement(new Coordinates(20,80));
        coordinates.addElement(new Coordinates(40,80));
        coordinates.addElement(new Coordinates(40,100));
        coordinates.addElement(new Coordinates(60,100));
        //wall 2
        coordinates.addElement(new Coordinates(40,40));
        coordinates.addElement(new Coordinates(60,40));
        coordinates.addElement(new Coordinates(80,40));
        coordinates.addElement(new Coordinates(80,60));
        //wall 3
        coordinates.addElement(new Coordinates(120,20));
        coordinates.addElement(new Coordinates(120,40));
        coordinates.addElement(new Coordinates(120,60));
        //wall 4
        coordinates.addElement(new Coordinates(100,100));
        coordinates.addElement(new Coordinates(120,100));
        coordinates.addElement(new Coordinates(120,120));
        coordinates.addElement(new Coordinates(120,140));
        //wall 5
        coordinates.addElement(new Coordinates(160,80));
        coordinates.addElement(new Coordinates(160,100));
        coordinates.addElement(new Coordinates(160,120));
        //misc
        coordinates.addElement(new Coordinates(160,40));
        coordinates.addElement(new Coordinates(160,160));
        coordinates.addElement(new Coordinates(80,140));
        coordinates.addElement(new Coordinates(40,160));
        
        for(int i = 0; i < coordinates.size(); i++){
            Coordinates coords = (Coordinates) coordinates.elementAt(i);
            GameObject gameObject = new Solid(new BasicGameObject());
            mazeSegs.addElement(new MazeSeg(gameObject, coords));
        }
    }

    public void makeBorder(Coordinates maxScreenCoords){
        //First wall
        for (int i = 0; i < maxScreenCoords.getX(); i = i + 20){
            coordinates.addElement(new Coordinates(i,0));
        }
        //Second wall
        for (int i = maxScreenCoords.getY(); i > 0; i = i - 20){
            coordinates.addElement(new Coordinates(0,i));
        }
        //third wall
        for (int i = 0; i < maxScreenCoords.getY(); i = i + 20){
            coordinates.addElement(new Coordinates(maxScreenCoords.getX()-20,i));
        }
        //forth wall
        for (int i = maxScreenCoords.getX(); i > 0; i = i - 20){
            coordinates.addElement(new Coordinates(i,maxScreenCoords.getY()-20));
        }
    }

    public void addToList(Vector vector){
        for(int i = 0; i < mazeSegs.size(); i++){
            vector.addElement(mazeSegs.elementAt(i));
        }
        pacdots.addToList(vector);
    }

    public void addToLayerManager(LayerManager layerManager){
        for(int i = 0; i < mazeSegs.size(); i++){
            MazeSeg mazeSeg = (MazeSeg) mazeSegs.elementAt(i);
            mazeSeg.addToLayerManager(layerManager);
        }
        pacdots.addToLayerManager(layerManager);
    }
}
