/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.*;
import gamelibrary.game.Coordinates;

public class PacDot extends GameObjectDecorator{

    private Image spriteImg;
    private int sprWid = 10, sprHgt = 10;
    private Coordinates coordinates;
    private LayerManager layermanager;
    private boolean living;

    public PacDot(GameObject gameObject, Coordinates coordinates){
        super(gameObject);
        this.coordinates = coordinates;
        living = true;
        try
        {
            int[] seq = {0, 1};  //Frame sequence
            spriteImg = Image.createImage("/thing.png");
            sprite = new Sprite(spriteImg, sprWid, sprHgt);
            sprite.setFrameSequence(seq);
            sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        }
        catch(Exception e)
        {
            System.out.println("Error loading sprite!!");
        }
    }

    public Coordinates getCoordinates(){
        return coordinates;
    }

    public void addToLayerManager(LayerManager layerManager){
        this.layermanager = layerManager;
        layerManager.append(sprite);
    }

    public void resolveCollision(GameObject foreign){
        super.resolveCollision(foreign);
        die();
    }

    public boolean die(){
        super.die();
        layermanager.remove(sprite);
        return true;
    }

    public boolean collidesWith(GameObject foreign){
        boolean result = false;
        if (living){
            result = foreign.collidesWith(sprite);
        }
        return result;
    }

    public boolean collidesWith(Sprite otherSprite){
        return sprite.collidesWith(otherSprite, true);
    }
}
