/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.*;
import gamelibrary.game.Coordinates;

public class Player extends GameObjectDecorator{

    private Image spriteImg;
    private boolean living;
    private boolean isMirrored;
    private int speed;
    private Coordinates coordinates;
    private int lastX = 0;
    private int lastY = 0;

    public Player(GameObject gameObject, Coordinates coordinates){
        super(gameObject);
        this.coordinates = coordinates;
        isMirrored = false;
        living = true;
        speed = 2;
        try
        {
            int[] seq = {0, 0, 1, 1};  //Frame sequence
            spriteImg = Image.createImage("/pacman.png");
            spriteImg.getWidth();
            spriteImg.getHeight();
            sprite = new MySprite(spriteImg, 1, 2);
            sprite.setFrameSequence(seq);
            sprite.defineReferencePixel(sprite.getWidth()/2, sprite.getHeight()/2);
            sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        }
        catch(Exception e)
        {
            System.out.println("Error loading sprite!!");
        }
    }

    public boolean acceptInput(int keyMask){
        super.acceptInput(keyMask);
        if (living){
            int howFarX = 0;
            int howFarY = 0;
            if((keyMask & LEFT_PRESSED)!=0){
                if (!isMirrored){
                    sprite.setTransform(Sprite.TRANS_MIRROR);
                    isMirrored = true;
                }
                howFarX -= speed;
            }
            else if((keyMask & RIGHT_PRESSED)!=0){
                if (isMirrored){
                    sprite.setTransform(Sprite.TRANS_NONE);
                    isMirrored = false;
                }
                howFarX += speed;
            }
            else if((keyMask & UP_PRESSED)!=0){
                howFarY -= speed;
            }
            else if((keyMask & DOWN_PRESSED)!=0){
                howFarY += speed;
            }
            move(howFarX, howFarY);
        }
        return true;
    }

    public boolean move(int howFarX, int howFarY){
        super.move(howFarX, howFarY);
        coordinates.addX(howFarX);
        coordinates.addY(howFarY);
        sprite.nextFrame();
        sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        lastX = howFarX;
        lastY = howFarY;
        return true;
    }

    public boolean undoLastMove(){
        super.undoLastMove();
        move(-lastX, -lastY);
        return true;
    }

    public Coordinates getCoordinates(){
        return coordinates;
    }

    public void addToLayerManager(LayerManager layerManager){
        layerManager.append(sprite);
    }

    public boolean die(){
        super.die();
        living = false;
        return true;
    }

    public boolean collidesWith(GameObject foreign){
        return foreign.collidesWith(sprite);
    }

    public boolean collidesWith(Sprite otherSprite){
        return sprite.collidesWith(otherSprite, true);
    }
}
