/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gamelibrary.game;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 * @author Griff
 */
public class Midlet extends MIDlet implements CommandListener{

    private Command exitCommand;   // The command to exit the application
    private Display display;       // The unique display object for this midlet
    private MyCanvas canvas;          // A displayable object

    /**
     * Enters the active state, performs initialization once
     */
    public void startApp() {
        if(canvas==null)             // Do only once
        {
            display = Display.getDisplay(this);
            canvas = new MyCanvas();
            exitCommand = new Command("Exit", Command.EXIT, 0);
            canvas.addCommand(exitCommand);   // Add command to the textbox
            canvas.setCommandListener(this);  // Register a listener
            canvas.start();
        }
        display.setCurrent(canvas);   // Set textbox as current displayable object
    }

    /**
     * Enters paused state.
     */
    public void pauseApp() {
    }

    /**
     * Enters desstroyed state
     *
     * @param unconditional if true, MIDlet is required to exit unconditionally
     *
     */
    public void destroyApp(boolean unconditional) {
        canvas.stop();
        canvas = null;
    }

    /**
     * Responds to commands issued on a displayable object
     */
    public void commandAction(Command c, Displayable s)
    {
        if (c == exitCommand) {
            destroyApp(true);
            notifyDestroyed();
        }
    }
}