/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gamelibrary.gameobject;

/**
 *
 * Every GameObject is intended to have some kind of graphical represntation that can be added to the LayerManager.
 * @author Griff
 */
import javax.microedition.lcdui.game.*;
import gamelibrary.game.Coordinates;

public interface GameObject {

    //these shouldn't live here
    final static int LEFT_PRESSED = 4;
    final static int RIGHT_PRESSED = 32;
    final static int UP_PRESSED = 6;
    final static int DOWN_PRESSED = 64;
    
    public Coordinates getCoordinates();

    public void addToLayerManager(LayerManager layerManager);

    //the object may or may not die
    public boolean die();

    //the object may or may not move
    public boolean move(int howFarX, int howFarY);

    //the object may or may not undo it's last move
    public boolean undoLastMove();

    public void resolveCollision(GameObject foreign);

    public boolean collidesWith(GameObject foreign);

    public boolean collidesWith(Sprite otherSprite);

    //the object may or may not accept input
    public boolean acceptInput(int keyMask);
}
